#include <stdio.h>
#include <queue>

typedef queue<jugs_t *> q_jugs_t;

int Ca = -1;
int Cb = -1;

#define POUR_A_B 1
#define POUR_B_A 2
#define FILL_A   3
#define FILL_B   4
#define EMPTY_A  5
#define EMPTY_B  6

typedef struct *jugs{
  int a;
  int b;
  int n;
  jugs *prev;
  int op;
} jugs_t;


typedef vector<jugs_t*> v_jugs_t;

jugs_t *pour_a_b(jugs_t *j)
{
  jugs_t *tmp = new jugs_t;
  memcpy(tmp, j, sizeof(jugs_t));
  tmp->b = tmp->b + tmp->a;
  if(tmp->b > Cb) tmp->b = Cb;
  tmp->prev = j;
  tmp->op = POUR_A_B;
  return tmp;
}

jugs_t *pour_b_a(jugs_t *j)
{
  jugs_t *tmp = new jugs_t;
  memcpy(tmp, j, sizeof(jugs_t));
  tmp->a = tmp->a + tmp->b;
  if(tmp->a > Ca) tmp->b = Ca;
  tmp->prev = j;
  tmp->op = POUR_B_A;
  return tmp;
}

jugs_t *fill_a(jugs_t *j)
{
  jugs_t *tmp = new jugs_t;
  memcpy(tmp, j, sizeof(jugs_t));
  tmp->a = Ca;
  tmp->prev = j;
  tmp->op = FILL_A
  return tmp;
}

jugs_t *fill_b(jugs_t *j)
{
  jugs_t *tmp = new jugs_t;
  memcpy(tmp, j, sizeof(jugs_t));
  tmp->b = tmp->Cb;
  tmp->prev = j;
  tmp->op = FILL_B;
  return tmp;
}

jugs_t *empty_a(jugs_t *j)
{
  jugs_t *tmp = new jugs_t;
  memcpy(tmp, j, sizeof(jugs_t));
  tmp->a = 0;
  tmp->prev = j;
  tmp->op = EMPTY_A;
  return tmp;
}

jugs_t *empty_b(jugs_t *j)
{
  jugs_t *tmp = new jugs_t;
  memcpy(tmp, j, sizeof(jugs_t));
  tmp->b = 0;
  tmp->prev = j;
  tmp->op = EMPTY_B;
  return tmp;
}

jugs_t * solve(int Ca, int Cb, int N)
{
  q_jugs_t q;
  v_jugs_t v;
  int q = 0;
  jugs_t *start = new jugs_t, *tmp;

  ::Ca = Ca;
  ::Cb = Cb;

  start->a = Ca;
  start->b = Cb;
  start->n = N;
  start->prev = NULL;
  q.put(start);

  //wide first search
  while(1){
    tmp = q.get();
    v.putback(tmp);

    if(tmp->a == N || tmp->b == N){
      return tmp;
    }
    else {
      q.put(pour_a_b(tmp));
      q.put(pour_b_a(tmp));
      q.put(fill_a(tmp));
      q.put(fill_b(tmp));
      q.put(empty_a(tmp));
      q.put(empty_b(tmp));
    }
  }
}

void back_trace(jugs_t *j)
{
  jugs_t *tmp;
  tmp = j;
  int count = 0;
  int *operations = NULL;

  while(tmp->prev != NULL) {
    tmp = tmp->prev;
    count ++;
  }

  operations = new int[count];
  tmp = j;
  for(int i=0;i<count;i++){
    operations[j] = tmp->op;
    tmp = tmp->prev;
  }
}

int main(int argc, char *argv[])
{
  int Ca, Cb, N;
  jugst_t *tmp;
  
  scanf("%d", &Ca);
  scanf("%d", &Cb);
  scanf("%d", &N);
  
  tmp = solve(Ca, Cb, N);
  
  return 0;
}










